#!/bin/sh

# simple, complete script to start a jail.

# define the absolute path to the jail,
J=/usr/local/jails/jailed.userland.directory

# define the ip address for the jail,
I=10.0.1.192

# define a hostname,
H=fqdn.com

## the following lines are for using mdconfig file-backed disks, (disk images)
## for more information on using disk images, just check the handbook:
## http://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/disks-virtual.html#AEN24770
# 
# mdconfig -a -t vnode -f /usr/local/jails/jaildisk_file.dmg -u 192
# mount /dev/md192c $J
#
## regarding '-u 192' above,
## it can be handy to use some variant of a jail's respective IP address for
## it's disk image devide node id, so it's easy to track down on a full system

ifconfig en0 inet alias $I/32

mount -t procfs proc $J/proc
mount_devfs devfs $J/dev
## add additonal flags to mount_devfs, to hide unnecessary devices!!!
## check the man page for mount_devfs

jail $J $H $I /bin/sh /etc/rc
